/*******************************************************************************
Copyright © 2023 Sebastian Roith

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************/

window.TASK = {
	"code": "class PUNKT {\n    String name;\n    int x;\n    int y;\n    \n    String toString() {\n        String angabe;\n        angabe = this.x + \"|\" + this.y;\n        angabe = \"(\" + angabe + \")\";\n        angabe = this.name + angabe;\n        return angabe;\n    }\n}\n\n// Ab hier: Das „Hauptprogramm“\nPUNKT Punkt1 = null;\nPunkt1 = new PUNKT();\nPunkt1.x = 2;\nPunkt1.y = -4;\nPunkt1.name = \"P\";\nString angabe;\nangabe = Punkt1.toString();\nprint(\"Ergebnis: \" + angabe);",
	"classes": [
		{
			"className": "PUNKT",
			"atts": [
				{
					"key": "name",
					"type": "String",
					"value": ""
				},
				{
					"key": "x",
					"type": "int",
					"value": 0
				},
				{
					"key": "y",
					"type": "int",
					"value": 0
				}
			],
			"abstract": true
		}
	],
	"notSelectable": [
		4,
		11,
		12,
		13,
		14
	],
	"methodCalls": [
		5
	],
	"classDeclarations": [
		{
			"line": 0,
			"className": "PUNKT"
		}
	],
	"steps": [
		{
			"task": "<p>Schritt für Schritt zeigt dir diese Aufgabe, wie Klassen in Java funktionieren. Lies dir bei jedem Schritt die Aufgabenstellung genau durch. Mit dessen Hilfe kannst du die richtigen Änderungen in der Speichertabelle vornehmen und dann die passende, als nächstes auszuführende Anweisung auswählen.</p><p>Wähle nun die erste Anweisung des „Hauptprogramms“ aus, um zu starten.</p>",
			"line": -1,
			"enableTextOut": true
		},
		{
			"task": "Jeder Klassenname taugt auch als Typ einer Variablen. Deren Standardwert ist <code>null</code>.",
			"line": 15,
			"vars": []
		},
		{
			"task": "<p>Mit <code>new PUNKT()</code> wird ein neues Objekt der Klasse <code>PUNKT</code> erzeugt. Die Zuweisung bewirkt, dass die Variable <code>Punkt1</code> auf das neu erzeugte Objekt zeigt.</p><p>Das kannst du nachspielen: Klicke bei der Klassendefinition auf <em>Erzeugen</em>.</p>",
			"line": 16,
			"vars": [
				{
					"key": "Punkt1",
					"type": "PUNKT",
					"ref": null
				}
			]
		},
		{
			"task": "Ergänze nun schrittweise die Attribute laut Klassendefinition. Klicke dazu nacheinander auf die Deklarationen und führe sie aus.",
			"line": 0,
			"vars": [
				{
					"key": "Punkt1",
					"type": "PUNKT",
					"ref": null
				}
			]
		},
		{
			"line": 1,
			"vars": {
				"instances": [],
				"vars": [
					{
						"key": "Punkt1",
						"type": "PUNKT",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": "PUNKT",
						"line": 16,
						"vars": []
					}
				]
			}
		},
		{
			"line": 2,
			"vars": {
				"instances": [],
				"vars": [
					{
						"key": "Punkt1",
						"type": "PUNKT",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": "PUNKT",
						"line": 16,
						"vars": [
							{
								"key": "name",
								"type": "String",
								"value": ""
							}
						]
					}
				]
			}
		},
		{
			"task": "Nach dem letzten Attribut: Schließe die Objekterzeugung durch Anklicken von 💾 ab. Dadurch wird das erzeugte Objekt in die Speichertabelle eingetragen. Nun kannst du die Wertezuweisung <code>Punkt1 = new PUNKT();</code> ausführen und die nächste Anweisung auswählen.",
			"line": 3,
			"vars": {
				"instances": [],
				"vars": [
					{
						"key": "Punkt1",
						"type": "PUNKT",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": "PUNKT",
						"line": 16,
						"vars": [
							{
								"key": "name",
								"type": "String",
								"value": ""
							},
							{
								"key": "x",
								"type": "int",
								"value": 0
							}
						]
					}
				]
			}
		},
		{
			"task": "Attributwerte kannst du (wie gewohnt) mittels Punktnotation ändern.",
			"line": 17,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "name",
								"type": "String",
								"value": ""
							},
							{
								"key": "x",
								"type": "int",
								"value": 0
							},
							{
								"key": "y",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "Punkt1",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"line": 18,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "name",
								"type": "String",
								"value": ""
							},
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "Punkt1",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"line": 19,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "name",
								"type": "String",
								"value": ""
							},
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": -4
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "Punkt1",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"task": "So eine Anweisung kennst du bereits: Einfach ausführen!",
			"line": 20,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "name",
								"type": "String",
								"value": "P"
							},
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": -4
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "Punkt1",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"task": "Das ist ein Methodenaufruf. Es geht also mit der Definition der Methode <code>toString()</code> weiter.",
			"line": 21,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "name",
								"type": "String",
								"value": "P"
							},
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": -4
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "Punkt1",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "angabe",
						"type": "String",
						"value": ""
					}
				],
				"scopes": []
			}
		},
		{
			"task": "Wann immer du eine Methode eines Objektes aufrufst, wird <code>this</code> auf das fragliche Objekt gesetzt. In der Speichertabelle erreichst du das, indem du die richtige Adresse für <code>this</code> auswählst. Von nun befindest du dich innerhalb eines <em>Methodenaufrufs</em>, den du erst durch Anklicken von ❌ schließt, wenn die Methode vollständig abgearbeitet ist. Starte mit der ersten Anweisung der Methode.",
			"line": 5,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "name",
								"type": "String",
								"value": "P"
							},
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": -4
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "Punkt1",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "angabe",
						"type": "String",
						"value": ""
					}
				],
				"scopes": []
			}
		},
		{
			"task": "Diese Variablendeklaration bewirkt, dass es eine neue Variable <em>im aktuellen Methodenaufruf</em> gibt.",
			"line": 6,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "name",
								"type": "String",
								"value": "P"
							},
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": -4
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "Punkt1",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "angabe",
						"type": "String",
						"value": ""
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 21,
						"vars": [
							{
								"key": "this",
								"ref": 0
							}
						]
					}
				]
			}
		},
		{
			"task": "In aktuellen Methodenaufruf ist ja <code>this</code> das aktuelle Objekt, auf das auch <code>Punkt1</code> zeigt. Entsprechend ist <code>this.x</code> Dasselbe wie <code>Punkt1.x</code> usw.",
			"line": 7,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "name",
								"type": "String",
								"value": "P"
							},
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": -4
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "Punkt1",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "angabe",
						"type": "String",
						"value": ""
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 21,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "angabe",
								"type": "String",
								"value": ""
							}
						]
					}
				]
			}
		},
		{
			"task": "So eine Anweisung ist ja nichts Neues, oder?",
			"line": 8,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "name",
								"type": "String",
								"value": "P"
							},
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": -4
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "Punkt1",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "angabe",
						"type": "String",
						"value": ""
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 21,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "angabe",
								"type": "String",
								"value": "2|-4"
							}
						]
					}
				]
			}
		},
		{
			"line": 9,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "name",
								"type": "String",
								"value": "P"
							},
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": -4
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "Punkt1",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "angabe",
						"type": "String",
						"value": ""
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 21,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "angabe",
								"type": "String",
								"value": "(2|-4)"
							}
						]
					}
				]
			}
		},
		{
			"task": "<p>Bei <code>return</code> wird die Methode sofort verlassen und der nachfolgende Wert als Rückgabewert der Methode (also dessen Ergebnis) festgelegt.</p><p>Schließe nun also den aktuellen <em>Methodenaufruf</em>, indem du dort auf ❌ klickst. Vorher musst du aber die Zuweisung <code>angabe = Punkt1.toString();</code> fertig ausführen, indem du den Rückgabewert als Wert von <code>angabe</code> (außerhalb des Methodenaufrufs!) übernimmst. Weiter geht es mit der auf den Methodenaufruf folgenden Anweisung.</p>",
			"line": 10,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "name",
								"type": "String",
								"value": "P"
							},
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": -4
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "Punkt1",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "angabe",
						"type": "String",
						"value": ""
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 21,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "angabe",
								"type": "String",
								"value": "P(2|-4)"
							}
						]
					}
				]
			}
		},
		{
			"task": "So eine Anweisung ist ja nichts Neues, oder?",
			"line": 22,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "name",
								"type": "String",
								"value": "P"
							},
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": -4
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "Punkt1",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "angabe",
						"type": "String",
						"value": "P(2|-4)"
					}
				],
				"scopes": []
			}
		},
		{
			"line": "end",
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "name",
								"type": "String",
								"value": "P"
							},
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": -4
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "Punkt1",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "angabe",
						"type": "String",
						"value": "P(2|-4)"
					}
				],
				"scopes": []
			},
			"cout": "Ergebnis: P(2|-4)"
		}
	]
};